SystemOrganization addCategory: #'Prolog-Base'!


Object subclass: #Logic
	instanceVariableNames: 'answer varList unboundVars tempResult returnBlock outputStream inputStream database'
	classVariableNames: 'BinaryOp Database'
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicDontCare
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicRef
	instanceVariableNames: 'content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Object subclass: #LogicUnbound
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

ConsCell subclass: #PrologList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

PrologList subclass: #Relation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Base'!

Logic class
	instanceVariableNames: ''!

LogicDontCare class
	instanceVariableNames: ''!

LogicRef class
	instanceVariableNames: ''!

LogicUnbound class
	instanceVariableNames: ''!

PrologList class
	instanceVariableNames: ''!

Relation class
	instanceVariableNames: ''!


!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
= anObject
    ^true! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 6/24/2008 18:34'!
= anObject
    ^self logicValue = anObject! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 6/24/2008 18:34'!
== anObject
    ^self logicValue == anObject! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 6/24/2008 18:34'!
adaptToNumber: rcvr andSend: selector

	^ rcvr perform: selector with: self logicValue! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/24/2008 17:37'!
addVarFrom: aList

    aList head isConsCell ifTrue: [self addVarFrom: aList head].

	{aList head . aList tail} do: [:part |
            (part class == LogicRef 
				and: [part logicValue class == LogicUnbound]
				and: [(varList identityIncludes: part) not])
            ifTrue: [varList add: part]].

	aList tail isConsCell ifTrue: [self addVarFrom: aList tail]! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/24/2008 23:21'!
allBoundValue: aLogicRef

    | anAnswer |

	anAnswer := aLogicRef logicValue.
	anAnswer class == LogicUnbound ifTrue: [^ aLogicRef].

	anAnswer isConsCell ifFalse: [^ anAnswer].

	^ anAnswer class 
		head: (self allBoundValue: anAnswer head) tail: (self allBoundValue: anAnswer tail)
   ! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/24/2008 17:41'!
allValue: aLogicRef
        "Copy all the values to an instance
         the same class as the content of aLogicRef.
         If aLogicRef's content is a List, walk
         through all elements."
    | anAnswer |

	(anAnswer := aLogicRef logicValue) isConsCell
        ifFalse: [^ anAnswer].

	^ anAnswer class 
		head: (self allValue: anAnswer head) tail: (self allValue: anAnswer tail)
   ! !

!Collection methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 15:21'!
asPrologList

	| cons |

	self size = 0 ifTrue: [^ nil].
	self size = 1 ifTrue: [^ PrologList car: (self at: 1) asPrologList].

	self reverseDo: [:elt | 
		cons _ PrologList car: elt asPrologList cdr: cons].
	^ cons
! !

!ConsCell methodsFor: '*Prolog-Base' stamp: 'spfa 6/29/2008 10:20'!
asPrologList

	^ PrologList head: car asPrologList tail: cdr asPrologList! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 15:20'!
asPrologList

	^ self! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 6/29/2008 10:34'!
asPrologList

	^ self! !

!String methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 15:21'!
asPrologList

	^ self! !

!Symbol methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 15:21'!
asPrologList

	self == #~ ifTrue: [^ LogicRef new].
	self == #~~ ifTrue: [^ LogicDontCare new].
	^ self! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 6/24/2008 18:35'!
at: anObject
    ^self logicValue at: anObject! !

!Logic methodsFor: 'query' stamp: 'spfa 6/24/2008 19:44'!
buildQuery: aList
        "Private"
    | pred block |
    (pred := aList head) ifNotNil: [self addVarFrom: pred].
    block := (aList tail ifNil: [[self inferAnswer]]
						ifNotNil: [self buildQuery: aList tail]).
    ^[self doGoal: pred onSuccess: block]! !

!Logic methodsFor: 'private' stamp: 'spfa 6/23/2008 15:42'!
check: assoc forArity: aNumber

	| n |
	
	n _ assoc key ifNil: [0] ifNotNil: [assoc key length].
	n = aNumber ifFalse: 
		[self error: 'bad numbers of arguments (expected ', aNumber asString, ', given ', n asString,')'].! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content
    ^content! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
content: anObject
    content := anObject! !

!Logic class methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
database
    ^Database! !

!Logic methodsFor: 'query' stamp: 'spfa 6/23/2008 15:22'!
doGoal: aRelation continue: aBlock
	"Try to satisfy aRelation as a goal."
	| blk mark |
	mark := unboundVars size.
	aRelation isPrologGoal ifFalse: [self error: 'not a goal'].
	blk := self doGoal: aRelation onSuccess: aBlock.
	[(blk _ blk value) isBlock] whileTrue.
	self unbindVar: mark! !

!Logic methodsFor: 'query' stamp: 'spfa 6/19/2008 21:05'!
doGoal: pred onSuccess: block

	^ self perform: (self class selectorForPredicate: pred head) 
		with: (pred tail -> block)! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/20/2008 10:26'!
doesNotUnderstand: aMessage

     | temp pred |

	"logic... method or primlogic... primitive"
	(self class canUnderstand: 
		(temp _ self class selectorForPredicate: aMessage selector))
		ifTrue: [^ self perform: temp with: aMessage arguments first].

	"database lookup"
    pred := self database at: temp 
		ifAbsent: [^ self error: 'Undefined predicate: ', temp].
    ^self retrieve: (aMessage arguments at: 1) from: pred
! !

!LogicRef methodsFor: 'wrapper' stamp: 'spfa 6/24/2008 18:34'!
doesNotUnderstand: aMessage
    ^self logicValue
        perform: aMessage selector
        withArguments: aMessage arguments! !

!Logic methodsFor: 'private' stamp: 'spfa 6/19/2008 17:05'!
first: assoc
        "Private -- Answer the first argument."
    ^ assoc key head logicValue
   ! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 6/24/2008 17:33'!
getValueFrom: anObject

    | lastNode |

	lastNode := self lastNode.

    (anObject class == LogicRef
		and: [anObject lastNode == lastNode])
    ifTrue: [^ self].
            
    lastNode content: anObject! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 6/23/2008 15:01'!
head
    ^ car! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 09:44'!
head

	^ nil! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 6/23/2008 15:01'!
head: anObject
    self car: anObject! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 6/23/2008 15:02'!
head: aObject tail: bObject
    ^self basicNew
        head: aObject;
        tail: bObject;
        yourself! !

!Logic methodsFor: 'private' stamp: 'spfa 6/23/2008 21:08'!
inferAnswer
        "Private -- Add an Array of values to
         the answer collection."

	answer add: (Array streamContents: [:str |
   						 varList do: [:x | str nextPut: (self allValue: x)]])! !

!Logic methodsFor: 'private' stamp: 'spfa 6/26/2008 13:50'!
inferSmalltalk: aList

        "Private -- Handle query from Smalltalk. aList
         contains a list of predicates."

    | blk |

    varList := OrderedCollection new.
    answer := OrderedCollection new.
    returnBlock := [
        self unbindVar: 0.
        answer size = 0
            ifTrue: [^nil]
            ifFalse: [^answer asArray]].
    blk := self buildQuery: aList.
    [(blk _ blk value) isBlock] whileTrue.
    ^returnBlock value! !

!Logic methodsFor: 'initialization' stamp: 'mt 6/28/1999 12:00'!
initialize
        "Private -- Initialize instance variables."
    unboundVars := OrderedCollection new: 2000! !

!Logic class methodsFor: 'initialize-release' stamp: 'spfa 6/17/2008 10:27'!
initialize
        "Initialize Database."
    Database := IdentityDictionary new! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/25/2008 11:37'!
inputStream

	^ inputStream ifNil: [inputStream := ReadWriteStream on: '']! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/25/2008 23:27'!
inputStream: aReadStream

	inputStream _ aReadStream! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 15:22'!
isPrologGoal

	^ false! !

!PrologList methodsFor: 'testing' stamp: 'spfa 6/23/2008 15:22'!
isPrologGoal

	^ car isSymbol! !

!PrologList methodsFor: 'testing' stamp: 'spfa 6/23/2008 14:40'!
isRelation

	^ false! !

!Relation methodsFor: 'testing' stamp: 'spfa 6/23/2008 14:10'!
isRelation

	^ true! !

!LogicRef methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
lastNode
    | aNode |
    aNode := self.
    [aNode content class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!LogicRef methodsFor: 'accessing' stamp: 'spfa 6/24/2008 17:36'!
logicValue
    | aNode |
    aNode := content.
    [aNode class == LogicRef]
        whileTrue: [aNode := aNode content].
    ^aNode! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 6/19/2008 17:01'!
logicValue

	^ self ! !

!Logic class methodsFor: 'as yet unclassified' stamp: 'spfa 6/20/2008 01:02'!
makeLogicSelector: aString

	(aString beginsWith: self prologKeyword)
		ifTrue: ["for safety only... this should not happen" ^ aString asSymbol].

	^ (self prologKeyword, (aString first: 1) asUppercase, aString allButFirst) asSymbol! !

!Logic class methodsFor: 'instance creation' stamp: 'mt 6/28/1999 12:00'!
new
    ^super new initialize! !

!LogicRef class methodsFor: 'accessing' stamp: 'spfa 6/19/2008 17:15'!
new
    ^super new content: LogicUnbound new! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/17/2008 10:59'!
outputStream

	^ outputStream ifNil: [outputStream := WriteStream on: '']! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/20/2008 12:44'!
outputStream: aWriteStream

	outputStream _ aWriteStream! !

!Collection methodsFor: '*Prolog-Base' stamp: 'spfa 6/24/2008 19:30'!
printElementsForPrologOn: aStream
	aStream nextPut: $(.
	self do: [:element | element printForPrologOn: aStream. aStream space].
	self isEmpty ifFalse: [aStream skip: -1].
	aStream nextPut: $)! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 13:58'!
printForPrologOn: aStream

	self printOn: aStream! !

!PrologList methodsFor: 'printing' stamp: 'spfa 6/23/2008 15:01'!
printForPrologOn: aStream
    aStream nextPut: $[.
    self printOne: aStream.
    car ifNotNil: [aStream skip: -1].
    aStream nextPut: $]! !

!Relation methodsFor: 'printing' stamp: 'spfa 6/26/2008 13:59'!
printForPrologOn: aStream
	car isSymbol
		ifTrue: [aStream nextPutAll: car]
		ifFalse: [car printOn: aStream].
    aStream nextPut: $(.
    (cdr isConsCell)
        ifTrue: [cdr printOne: aStream with: ', '. cdr ifNotNil: [aStream skip: -2]]
        ifFalse: [cdr ifNotNil: [cdr printOn: aStream]].
    aStream nextPut: $)! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 14:01'!
printForPrologOn: aStream

	aStream nextPutAll: '[]'! !

!LogicDontCare methodsFor: 'accessing' stamp: 'mt 6/28/1999 12:00'!
printOn: aStream
    aStream nextPutAll: '_';
        nextPut: $ ! !

!LogicRef methodsFor: 'printing' stamp: 'spfa 6/24/2008 17:36'!
printOn: aStream
    self logicValue printOn: aStream! !

!LogicUnbound methodsFor: 'printing' stamp: 'spfa 6/16/2008 10:40'!
printOn: aStream
    #Unbound printOn: aStream.
	self hash printOn: aStream
! !

!PrologList methodsFor: 'printing' stamp: 'spfa 6/23/2008 15:03'!
printOn: aStream

	self printForPrologOn: aStream
    ! !

!Relation methodsFor: 'printing' stamp: 'spfa 6/24/2008 21:14'!
printOn: aStream
	self printForPrologOn: aStream! !

!PrologList methodsFor: 'printing' stamp: 'spfa 6/23/2008 15:01'!
printOne: aStream
    car printOn: aStream.
    aStream nextPut: $ .
    (cdr isConsCell)
        ifTrue: [cdr printOne: aStream]
        ifFalse: [cdr ifNil: [^ self].
            aStream nextPutAll: '| '.
            cdr printOn: aStream]! !

!PrologList methodsFor: 'printing' stamp: 'spfa 6/23/2008 15:01'!
printOne: aStream with: separators
    car printOn: aStream.
    aStream nextPutAll: separators.
    (cdr isConsCell)
        ifTrue: [cdr printOne: aStream with: separators]
        ifFalse: [cdr ifNil: [^ self].
            aStream nextPutAll: '| '.
            cdr printOn: aStream]! !

!Logic class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:25'!
prologKeyword

	^ 'logic'
! !

!Object methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 13:58'!
prologPrintString

	^ String streamContents: [:s | self printForPrologOn: s]! !

!Logic methodsFor: 'query' stamp: 'spfa 6/23/2008 22:51'!
retrieve: assoc from: dataList
        "Retrieve a fact in assoc from
         Database entry dataList."

    (dataList ifNil: [^self]) 
		do: [:elt | self unify: assoc key with: elt then: assoc value]! !

!Logic methodsFor: 'private' stamp: 'spfa 6/19/2008 17:04'!
second: assoc
        "Private -- Answer the second argument."
    ^ assoc key tail head logicValue! !

!LogicDontCare methodsFor: 'parser support' stamp: 'bolot 7/19/1999 17:55'!
size
	" symbol used for LogicDontCare is '_' (underscore) "
	^self printString size! !

!Logic methodsFor: 'accessing' stamp: 'spfa 6/24/2008 18:57'!
structureHead: aSymbol arguments: anInteger
        "Answer a structure whose functor is
         aSymbol and arguments are anInteger
         number of DontCares."
    | aRelation |
    aRelation := Relation with: aSymbol.
    anInteger timesRepeat: [
        aRelation addLast: LogicDontCare new].
    ^aRelation! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 6/23/2008 15:01'!
tail
    ^cdr! !

!UndefinedObject methodsFor: '*Prolog-Base' stamp: 'spfa 6/23/2008 09:41'!
tail

	^ nil! !

!PrologList methodsFor: 'aliases' stamp: 'spfa 6/23/2008 15:02'!
tail: anObject
    self cdr: anObject! !

!Relation methodsFor: 'private' stamp: 'spfa 6/24/2008 18:18'!
tailClass

	^ PrologList

! !

!Logic methodsFor: 'private' stamp: 'spfa 6/19/2008 17:05'!
third: assoc
        "Private -- Answer the third argument."
    ^ assoc key tail tail head logicValue! !

!Logic methodsFor: 'private' stamp: 'mt 6/28/1999 12:00'!
unbindVar: mark
        "Private -- Unbind previously bound variables
         down to mark."
    | index |
    [(index := unboundVars size) > mark]
        whileTrue: [
            (unboundVars at: index)
                content: LogicUnbound new.
            unboundVars removeLast]! !

!Logic methodsFor: 'query' stamp: 'spfa 6/24/2008 23:02'!
unify: x with: y
        "Private -- Attempt to unify x with y, return true
         or false depending on success"
    | xLast yLast |

    (x class == LogicDontCare or: [y class == LogicDontCare])
         ifTrue: [^ true].

	xLast _ x class == LogicRef  ifTrue: [x lastNode] ifFalse: [x].

   	(xLast class == LogicRef) ifTrue: [
            xLast logicValue class == LogicUnbound
                ifTrue: [
                    unboundVars add: xLast.
                    xLast getValueFrom: y.
                    ^true]
                ifFalse: [xLast := xLast logicValue]].

	yLast _ y class == LogicRef  ifTrue: [y lastNode] ifFalse: [y].

    (yLast class == LogicRef) ifTrue: [
            yLast logicValue class == LogicUnbound
                ifTrue: [
                    unboundVars add: yLast.
                    yLast getValueFrom: x.
                    ^true]
                ifFalse: [yLast := yLast logicValue]].

	(xLast isConsCell and: [yLast isConsCell])
		ifFalse: [^ xLast = yLast].

	xLast class == yLast class ifFalse: [^ false].

    (self unify: xLast head with: yLast head)
         ifTrue: [^ self unify: xLast tail with: yLast tail].

	^ false
    ! !

!Logic methodsFor: 'query' stamp: 'spfa 6/24/2008 17:46'!
unify: x with: y then: aBlock
        "Private -- If x unifies with y, then execute
         aBlock. Answer self."
    | mark blk |
    mark _ unboundVars size.
	blk _ aBlock.
    (self unify: x with: y) ifTrue: [[(blk _ blk value) isBlock] whileTrue].
    self unbindVar: mark! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 6/23/2008 15:02'!
with: anObject
    ^self car: anObject! !

!PrologList class methodsFor: 'as yet unclassified' stamp: 'spfa 6/23/2008 15:02'!
with: anObject with: bObject
    ^self car: anObject cdr: (self car: bObject)! !
Logic initialize!
