SystemOrganization addCategory: #'Prolog-Core'!


Logic subclass: #Prolog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog subclass: #Doctor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog subclass: #Family
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

HierarchyBrowser subclass: #PrologBrowser
	instanceVariableNames: 'repl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

PackageInfo subclass: #PrologInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

REPLMorph subclass: #PrologREPLMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Workspace subclass: #PrologWorkspace
	instanceVariableNames: 'doItReceiverPrototype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Core'!

Prolog class
	instanceVariableNames: 'LocalDatabase Predicates'!

Doctor class
	instanceVariableNames: ''!

Family class
	instanceVariableNames: ''!

PrologBrowser class
	instanceVariableNames: ''!

PrologInfo class
	instanceVariableNames: ''!

PrologREPLMorph class
	instanceVariableNames: ''!

PrologWorkspace class
	instanceVariableNames: ''!


!Doctor commentStamp: 'bolot 12/13/2002 15:59' prior: 0!
A demo class.

Used by Family>>health:

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Family commentStamp: 'bolot 12/13/2002 15:24' prior: 0!
A demo class
Examples:
LCompiler evaluate: 'Family new :? father(x,y)'
LCompiler evaluate: 'Family new :? grandPa(''John'',y)'

This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.
We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!Prolog commentStamp: 'bolot 12/13/2002 15:12' prior: 0!
This class and other related classes in this category were originally written by Mike Teng <miket@objectshare.com>, then at Digitalk, as part of the Prolog/V implementation distributed with Smalltalk V/286 in 1988.  We gratefully acknowledge Mike's permission to port his code to Squeak.

The port to Squeak is the work of Bolot Kerimbaev <bolot@cc.gatech.edu>, a summer intern at Walt Disney Imagineering.!

!PrologWorkspace commentStamp: 'bolot 12/13/2002 15:47' prior: 0!
PrologWorkspace

enables "pure" Prolog syntax to be used, instead of directly invoking LCompiler

try these:

Family new :? father(x,y)
Family new :? grandPa('John',y)
!

!Prolog class methodsFor: 'querying' stamp: 'spfa 6/18/2008 15:13'!
? anObject
	"Evaluating anObject in the context of this class."

	anObject isString ifTrue: [^ self evaluate: anObject].

	^ self which: anObject
! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
acceptsLoggingOfCompilation
	^true! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/21/2008 15:54'!
addItemsToREPLMenu: aMenu.

	aMenu addLine; 
		add: 'explore database' target: self database selector: #explore;
		add: 'explore predicates cache' target: self class predicates selector: #explore;
		add: 'clear predicates cache' target: self class selector: #clearPredicates.
	! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:38'!
addLowerPanesTo: window at: nominalFractions with: editString

	| verticalOffset row innerFractions m |

	row := AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		borderColor: Color black;
		layoutPolicy: ProportionalLayout new.

	verticalOffset := 0.
	innerFractions := 0@0 corner: 1@0.
	verticalOffset := self addOptionalAnnotationsTo: row at: innerFractions plus: verticalOffset.
	verticalOffset := self addOptionalButtonsTo: row  at: innerFractions plus: verticalOffset.

	row 
		addMorph: ((m _ self buildMorphicCodePaneWith: editString) borderWidth: 0)
		fullFrame: (
			LayoutFrame 
				fractions: (innerFractions withBottom: 1) 
				offsets: (0@verticalOffset corner: 0@0)
		).
	window 
		addMorph: row
		frame: nominalFractions.

	row on: #mouseEnter send: #paneTransition: to: window.
	row on: #mouseLeave send: #paneTransition: to: window.

	m hasUnacceptedEdits: false! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/23/2008 14:22'!
additionalPackages
	"These are the names of packages that get loaded before the main change set"
	^#('Prolog-Documentation' 'Prolog-Dungeon' 'Prolog-Tests') ! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/18/2008 15:23'!
assert: anArray

	^ self assertz: anArray! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/23/2008 21:16'!
asserta: anArray

	| relation list |

	relation _ anArray asPrologList.
	list _ self database at: relation head ifAbsent: 
		[^ self database at: relation head put: (PrologList car: relation tail)].
	list at: relation head put: (PrologList head: relation tail tail: list).
	^ self database at: relation head! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/23/2008 21:16'!
assertz: anArray

	| relation |

	relation _ anArray asPrologList.

	(self database at: relation head ifAbsent: 
		[^ self database at: relation head put: (PrologList car: relation tail)])
			addLast: relation tail.
	^ self database at: relation head! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:15'!
classListIndex: anInteger 

	super classListIndex: anInteger .
	self selectedClass ifNil: [^self].
	(self selectedClass == Prolog
		or: [self selectedClass inheritsFrom: Prolog])
		ifTrue: [repl evaluator: self selectedClass new]
	! !

!Prolog class methodsFor: 'predicates' stamp: 'spfa 6/19/2008 21:30'!
clearPredicates

	Predicates _ nil! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/7/1999 20:15'!
compilerClass
	^LCompiler! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/20/2008 10:37'!
database

	^ self databaseScope caseOf:
	{
		[#global] -> [Database].
		[#classLocal] -> [self localDatabase].
		[#instanceLocal] -> [self error: 'instance-local database (out of scope)'].
	} 
	otherwise: [self error: 'undefined database scope']! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/20/2008 10:35'!
database

	^ self databaseScope caseOf:
	{
		[#global] -> [Database].
		[#classLocal] -> [self class localDatabase].
		[#instanceLocal] -> [self localDatabase].
	} 
	otherwise: [self error: 'undefined database scope']! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/20/2008 10:28'!
databaseScope

	^ #global! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/20/2008 10:28'!
databaseScope

	^ self class databaseScope! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/17/2008 21:57'!
decompilerClass
	"Answer a decompiler class appropriate for compiled methods of this class."

	^LDecompiler! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'spfa 6/26/2008 14:40'!
demoString
	^
'Family example:

Family new :? father(x,y)
Family new :? grandPa(''John'',y)

Family new :? father(x, ''Mary'')
Family new :? father(''John'', ''Mary'')

Family new :? grandPa(''John'', x), father(y, x)

Family new :? health(''John'', y).
Family new :? consult( healthHistory(''John'', x), Doctor new)


GUI:

Family new openGui


Database:

Family new :? database(brother()). 
Family new :? assertz(brother(''John'', ''Stewart'')), asserta(brother(''John'', ''Barbara'')), assertz(brother(''John'', ''Alan'')).

Family new :? brother(x,y). 

Family new :? retract(brother(''John'', ''Stewart'')).

Family new :? brother(x,y).

Family new :? purgeDatabase(brother()).



Dungeon new :? go


Resources:

Prolog Tutorial
http://www.csupomona.edu/~jrfisher/www/prolog_tutorial/contents.html
'! !

!PrologWorkspace methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:46'!
doItReceiver
	^doItReceiverPrototype ifNil: [doItReceiverPrototype _ Prolog new]! !

!PrologWorkspace methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 13:38'!
doItReceiver: aProlog
	doItReceiverPrototype _ aProlog! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/20/2008 12:57'!
doTranscript

	self outputStream: Transcript! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/9/2008 14:50'!
evalString: aString

	^ LCompiler evaluate: 'self yourself :? ', aString for: self logged: false! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 00:17'!
evalString: aString notifying: requestor

	^ LCompiler evaluate: 'self yourself :? ', aString for: self notifying: requestor logged: false! !

!Prolog class methodsFor: 'querying' stamp: 'spfa 6/16/2008 23:37'!
evaluate: aString
	"Evaluating aString in the context of this class."

	^ LCompiler evaluate: 'self yourself :? ', aString for: self new logged: false! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 8/5/1999 16:21'!
evaluatorClass
	"Answer an evaluator class appropriate for evaluating expressions in the 
	context of this class."

	^LCompiler! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/20/2008 12:55'!
finalizeOutput

	outputStream == Transcript
		ifTrue: [outputStream endEntry]! !

!PrologREPLMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/24/2008 19:29'!
formatAnswer: anObject

	anObject isEmptyOrNil ifTrue: [^ 'No.']. "can be empty after a cut"
	anObject = #(()) ifTrue: [^ 'Yes.'].

	^ String streamContents: [:str |
		anObject do: [:elt |
			elt size isZero ifTrue: [str nextPutAll: 'Yes.']
				ifFalse: [
					elt size = 1 ifTrue: [elt first printForPrologOn: str]
						ifFalse: [elt printElementsForPrologOn: str]
				].
			str cr].
		str skip: -1]
! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/21/2008 15:47'!
gui

	| window color browser hSepFrac repl |

	repl := PrologREPLMorph on: self.
	browser := PrologBrowser new repl: repl; initHierarchyForClass: Prolog.
"	browser repl: repl."
	browser selectClass: self class.
	window := (SystemWindow labelled: browser labelString, ' & REPL' ) model: browser.

"	self addDependent: window."

	color := self guiColor.
	window setProperty: #paneColor toValue: color.

	hSepFrac := 0.3.

	Preferences scrollBarsOnRight ifFalse:
		[browser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@1) 
			with: self guiDocumentation].

	browser 
		addClassAndSwitchesTo: window 
		at: (0.0@0 corner: 0.33@hSepFrac)
		plus: 0.
	window 
		addMorph: browser buildMorphicMessageCatList
		frame: (0.33@0 extent: 0.33@hSepFrac).
	window addMorph: browser buildMorphicMessageList
		frame: (0.66@0 extent: 0.34@hSepFrac).

	Preferences scrollBarsOnRight ifTrue:
		[browser 
			addLowerPanesTo: window 
			at: (0@hSepFrac corner: 1@0.6) 
			with: self guiDocumentation].

	window setUpdatablePanesFrom: #(classList messageCategoryList messageList).

	window addMorph: repl	frame: (0@0.6 corner: 1@1).

	^ window
! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/16/2008 13:13'!
guiColor

	^ Color blue muchLighter! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/17/2008 01:19'!
guiDocumentation

	^'"
Use the read-eval-print loop listener below to query the currently selected Prolog subclass.
Choose the ''decompile'' display option to inspect the actual Smalltalk code for logic predicates
(that''s the right-most button)

"'! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:43'!
initHierarchyForClass: aClassOrMetaClass
	| tab stab index nonMetaClass |
	centralClass := aClassOrMetaClass.
	nonMetaClass := aClassOrMetaClass theNonMetaClass.
	self systemOrganizer: SystemOrganization.
	metaClassIndicated := aClassOrMetaClass isMeta.
	classList := OrderedCollection new.
	tab := ''.
	nonMetaClass allSuperclasses reverseDo: 
		[:aClass | 
		(Prolog inheritsFrom: aClass)
			ifFalse: [
				classList add: tab , aClass name.
				tab := tab , '  ']].
	index := classList size + 1.
	nonMetaClass allSubclassesWithLevelDo:
		[:aClass :level |
		stab := ''.  1 to: level do: [:i | stab := stab , '  '].
		classList add: tab , stab , aClass name]
	 	startingLevel: 0.
	self classListIndex: index! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:33'!
labelString

	^ 'Prolog Browser'! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/20/2008 10:23'!
localDatabase

	^ database ifNil: [database _ IdentityDictionary new]! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/18/2008 14:03'!
localDatabase

	^ LocalDatabase ifNil: [LocalDatabase _ IdentityDictionary new]! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/24/2008 23:07'!
logicArg

arg(n, structure, x) :-
	is(list, self allValue: structure),
	is(len, list logicValue length - 1),
	numlist(0,len,range),
	member(n, range),
	is(x, (list logicValue nth: n logicValue)), !!.

arg(n, structure, x) :-
	integer(n),
	integer(x),
	is(x, structure nth: n).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/24/2008 18:20'!
logicFather

father('John', 'Mary').  "John is the father of Mary"
father('John', 'David').
father('David', 'Jack').
father('Arthur', 'Nancy').
! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/24/2008 21:19'!
logicFunctor
	"The first argument can be either a
	Relation or a List whose first
	element is a Symbol."

functor(structure, head, arguments) :-
	univ(structure, [sHead | sTail]),
	atom(sHead),
	eq(head, sHead),
	is(arguments, sTail logicValue length).

functor(structure, head, arguments) :-
	var(structure),
	atom(head),
	integer(arguments),
	is(structure, self
		structureHead: head logicValue
		arguments: arguments logicValue).
! !

!Family methodsFor: 'demo' stamp: 'spfa 6/25/2008 23:46'!
logicGrandPa

"x is the grandPa of y."
grandPa(x, y) :-
	father(x, z),
	or(father(z, y),mother(z,y)).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/25/2008 23:02'!
logicHealth

"Return the health history of x."
health(x, history) :-
	consult( healthHistory(x, history), Doctor new).! !

!Doctor methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2008 21:27'!
logicHealthHistory

healthHistory('John', 'John had two times of heart attacks').
healthHistory('Mary', 'Mary had no serious problems').! !

!Prolog methodsFor: 'basics' stamp: 'spfa 6/23/2008 13:20'!
logicMember

member(x,[x|_]).
member(x,[_|r]) :- member(x,r).! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 21:28'!
logicMother

"Mary is the mother of Nancy."
mother('Mary', 'Nancy').! !

!Family methodsFor: 'demo' stamp: 'spfa 6/8/2008 23:03'!
logicParent

parent(x,y) :-
	or(father(x,y), mother(x,y)).! !

!Prolog methodsFor: 'structures' stamp: 'spfa 6/24/2008 23:21'!
logicUniv

univ(structure, list) :-
	nonvar(structure),
	is(true, structure isRelation),
	is(x, self allBoundValue: structure),
	is(list, PrologList
		head: x logicValue head
		tail: x logicValue tail),
	!!.

univ(structure, [head | list]) :-
	atom(head),
	is(x, self allValue: list),
	is(structure, Relation
		head: head logicValue
		tail: x logicValue).! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/20/2008 00:13'!
noteCompilationOf: aSelector meta: isMeta
	
	self withAllSubclassesDo: [:pl | pl clearPredicates]! !

!PrologREPLMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/26/2008 00:26'!
notify: string at: location in: source

	"in you see this in a debugger, printIt for details:"
	source contents copyReplaceFrom: location to: location - 1
							with: string. "printIt"

	^ self error: 'bad syntax'

! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'bolot 12/13/2002 15:45'!
open
	self openLabel: 'Prolog Workspace'! !

!PrologWorkspace class methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 09:04'!
openDemo
	"self openDemo"
	(self new contents: self demoString) openLabel: 'Prolog Workspace'! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/9/2008 14:55'!
openGui

	self gui openInWorld.! !

!Prolog class methodsFor: 'predicates' stamp: 'spfa 6/19/2008 21:10'!
predicates

	^ Predicates ifNil: [Predicates _ IdentityDictionary new]! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/23/2008 14:34'!
prerequisitePackages
	"These are the names of packages that get loaded before the main change set"
	^#('ConsCell' 'Prolog-Compiler' 'REPLMorph' 'Prolog-Base') ! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/23/2008 10:23'!
primlogicAnd: assoc
    "Try to satisfy a list of goals."
    | aList next |
    aList := assoc key.
	aList ifNil: [^ assoc value].
	next _ (Relation with: #primlogicAnd:) tail: aList tail.
   	self doGoal: aList head
          	continue: [self doGoal: next continue: assoc value]

 ! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/17/2008 10:28'!
primlogicAssert: assoc
        "Add the fact in assoc to the
         end of the database."
    ^ self primlogicAssertz: assoc! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/23/2008 21:20'!
primlogicAsserta: assoc
        "Add the fact in assoc to the
         beginning of the database."
    | arg aList |
    self check: assoc forArity: 1.
    arg := self allValue: (self first: assoc).
    aList := self database at: arg head ifAbsent:  [
		self database at: arg head put: (PrologList car: arg tail).
		^ assoc value].
    self database at: arg head put:
        (PrologList head: arg tail tail: aList).
    ^assoc value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/23/2008 21:34'!
primlogicAssertz: assoc
        "Add the fact in assoc to the
         end of the database."
    | arg aList |
    self check: assoc forArity: 1.
    arg := self allValue: (self first: assoc).
    aList := self database at: arg head ifAbsent: [
		self database at: arg head put: (PrologList car: arg tail).
		^ assoc value].
    aList ifNil: [self database at: arg head put: (PrologList car: arg tail)] 
		ifNotNil: [aList addLast: arg tail].
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/24/2008 19:09'!
primlogicAtom: assoc
        "Succeed if the argument is a Symbol."
    self check: assoc forArity: 1.

    (self first: assoc) isSymbol
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/24/2008 20:49'!
primlogicAtomic: assoc
        "Succeed if the argument is a Symbol
         or an integer."
    | arg |
    self check: assoc forArity: 1.
    ((arg := self first: assoc) isSymbol
    or: [arg isKindOf: Integer])
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/23/2008 15:43'!
primlogicCall: assoc
        "Execute the argument as a predicate."
    | blk |
    self check: assoc forArity: 1.
    (blk := self first: assoc) isPrologGoal ifFalse: [self error: 'not a goal'].
    ^[self doGoal: blk onSuccess: assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/23/2008 15:43'!
primlogicConsult: assoc
        "Ask the second argument as the receiver
         (a Smalltalk expression) to solve the goals
         contained in the first argument, e.g.
            consult(father(x, 'John'), family new)."
    | blk |
    self check: assoc forArity: 2.
    (blk := self first: assoc) isPrologGoal 
		ifFalse: [self error: 'first argument must be predicate'].
    ^[(self second: assoc) value
		doGoal: blk onSuccess: assoc value]! !

!Prolog methodsFor: 'backtracking' stamp: 'spfa 6/23/2008 15:43'!
primlogicCut: assoc 
	" Succeed always, exit the containing method
	  during backtacking."
	| blk mark |
    self check: assoc forArity: 1.
	mark _ unboundVars size.
	blk _ assoc value.
	[(blk _ blk value) isBlock] whileTrue.
	self unbindVar: mark.
	assoc key head value! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/25/2008 14:05'!
primlogicDatabase: assoc
        "Create a database which can hold facts
         being asserted or extracted. The argument
         must be a structure."
    | arg |
    self check: assoc forArity: 1.
    arg := self first: assoc.
    (arg isConsCell and: [arg isRelation] and: [arg head isSymbol])
        ifFalse: [self error: 'argument is not a fact'].
    self database at: arg head ifAbsent: [
        self database at: arg head put: nil].
    ^assoc value! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:39'!
primlogicEq: assoc
        "Succeed if the two arguments can be unified."
    self check: assoc forArity: 2.
    self unify: assoc key head
        with: assoc key tail head
        then: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:43'!
primlogicEquiv: assoc
        "Succeed if the two arguments are the same object."
    self check: assoc forArity: 2.
    (self first: assoc) == (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'backtracking' stamp: 'spfa 6/19/2008 16:51'!
primlogicExit: assoc
	" exit Prolog "
	| blk |
	blk _ assoc value.
	[(blk _ blk value) isBlock] whileTrue.
	^returnBlock value! !

!Prolog methodsFor: 'success-failure' stamp: 'spfa 6/8/2008 21:31'!
primlogicFail: assoc
        "Fail always."! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:43'!
primlogicGe: assoc
        "Succeed if the first argument is
         greater than or equal to the second."
    self check: assoc forArity: 2.
    (self first: assoc) >= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:43'!
primlogicGt: assoc
        "Succeed if the first argument is
         greater than the second."
    self check: assoc forArity: 2.
    (self first: assoc) > (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'debugging' stamp: 'spfa 6/23/2008 15:19'!
primlogicHalt: assoc
        "Halt the execution.  Smalltalk debugger
         can be invoked at this point."
    assoc key ifNotNil: [^self].
    self halt! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/23/2008 15:44'!
primlogicInteger: assoc
        "Succeed if the argument is an Integer."
    self check: assoc forArity: 1.
    ((self first: assoc) isKindOf: Integer)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/24/2008 22:29'!
primlogicIs: assoc
        "Execute the second argument as a Smalltalk
         expression and then unify its result with
         the first argument."
    self check: assoc forArity: 2.

    self unify: assoc key head 
        with: assoc key tail head logicValue value
        then: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:44'!
primlogicLe: assoc
        "Succeed if the first argument is
         less than or equal to the second."
    self check: assoc forArity: 2.
    (self first: assoc) <= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:44'!
primlogicLt: assoc
        "Succeed if the first argument is
         less than the second."
    self check: assoc forArity: 2.
    (self first: assoc) < (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:44'!
primlogicNe: assoc
        "Succeed if the first argument is
         greater than the second."
    self check: assoc forArity: 2..
    (self first: assoc) ~= (self second: assoc)
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/23/2008 15:18'!
primlogicNl: assoc
        "Write an end of line to the output stream"
    assoc key ifNotNil: [^self].
    self outputStream cr.
    self finalizeOutput.
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/23/2008 15:44'!
primlogicNonvar: assoc
        "Succeed if the argument is not an
         unbound variable."
    self check: assoc forArity: 1.
    (self first: assoc) class == LogicUnbound
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/23/2008 15:44'!
primlogicNot: assoc
        "Succeed if the evaluation of the argument
         as a goal fails."
    | blk |
     self check: assoc forArity: 1.
    (blk := self first: assoc) isPrologGoal 
		ifFalse: [self error: 'argument must be predicate'].
    blk := self doGoal: blk onSuccess: [^self].
	[(blk _ blk value) isBlock] whileTrue.
    ^assoc value! !

!Prolog methodsFor: 'comparing' stamp: 'spfa 6/23/2008 15:44'!
primlogicNotEquiv: assoc
        "Succeed if the two arguments
         are not the same object."
    self check: assoc forArity: 2.
    (self first: assoc) == (self second: assoc)
        ifFalse: [^assoc value]! !

!Prolog methodsFor: 'basics' stamp: 'spfa 6/23/2008 15:44'!
primlogicNumlist: assoc
        "Unify the third argument with a list of integers 
		within a range defined by the first arguments."
    self check: assoc forArity: 3.
    self unify: assoc key tail tail head 
		with: ((self first: assoc) to: (self second: assoc)) asArray asPrologList 
        	then: [^assoc value]

! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/23/2008 21:36'!
primlogicOr: assoc
    "Disjunction predicate."
    assoc key length isZero ifTrue: [^self].
	0 to: assoc key length - 1 do: [:i |
    		self doGoal: (assoc key nth: i) logicValue continue: assoc value]! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/23/2008 22:13'!
primlogicPurgeDatabase: assoc
        "Purge a database identified by the
         structure in the argument."
    | arg |
    self check: assoc forArity: 1.
    arg := self first: assoc.
    ((arg isRelation) and:
    [arg head isSymbol])
        ifFalse: [self error: 'argument is not a fact'].
    self database removeKey: arg head ifAbsent: [].
    ^assoc value! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/23/2008 15:46'!
primlogicRead: assoc
        "Read a Smalltalk expression, evaluate it and
         answer the result.  This can be used to input
         a Symbol, a number, a quoted string, etc."
    | anAnswer |
    self check: assoc forArity: 1.
    anAnswer := Compiler evaluate: (FillInTheBlank
		request: 'type a Smalltalk expression and accept'
		initialAnswer: '').
    self unify: assoc key head
        with: anAnswer
        then: [^assoc value]! !

!Prolog methodsFor: 'input-output' stamp: 'spfa 6/27/2008 19:58'!
primlogicReadstring: assoc
        "Read a string and answer the result."
    | anAnswer |
    self check: assoc forArity: 1.

	[self inputStream atEnd] whileTrue: [World doOneCycle. Processor yield].
"
    anAnswer := FillInTheBlank
		request: 'type a line and accept'
		initialAnswer: ''."
	anAnswer _ self inputStream contents.
 	self inputStream resetContents.

	self unify: assoc key head
        with: anAnswer
        then: [^assoc value]! !

!Prolog methodsFor: 'complex goals' stamp: 'spfa 6/23/2008 15:46'!
primlogicRepeat: assoc
        "Succeed always, even
         during backtacking."
    | blk mark |
    self check: assoc forArity: 0.
    mark := unboundVars size.
    [
        blk := assoc value.
        [(blk _ blk value) isBlock] whileTrue.
        self unbindVar: mark
	] whileTrue! !

!Prolog methodsFor: 'database' stamp: 'spfa 6/25/2008 14:00'!
primlogicRetract: assoc
        "Delete the first fact unified with the
         one in assoc from the database. Delete
         the next one during backtrack."
    | arg aList bList |

    self check: assoc forArity: 1.
    arg := self first: assoc.
    [aList := self database at: arg head ifAbsent: [^self].
     aList ifNil: [^self].
     self unify: arg tail
        with: aList head
        then: [self database at: arg head put: aList tail.
               assoc value value].
     aList == (self database at: arg head)]
        whileFalse: [].
    [(bList := aList tail) isNil] whileFalse: [
        self unify: arg tail
            with: aList tail head
            then: [aList tail: aList tail tail.
                   bList := aList.
                   assoc value value].
        aList := bList.
        aList ifNil: [^self]]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/23/2008 15:46'!
primlogicRuntime: assoc
        "Unify the first argument with
         the system time in milliseconds."
    self check: assoc forArity: 1.
    self unify: assoc key head
        with: Time millisecondClockValue
        then: [^assoc value]! !

!Prolog methodsFor: 'comm with smalltalk' stamp: 'spfa 6/23/2008 15:48'!
primlogicSend: assoc

	assoc key length < 3 ifTrue:
		[self check: assoc forArity: 3].

    assoc key length = 3 ifTrue: [
    	self unify: assoc key tail tail head 
			with: ((self first: assoc) perform: (self second: assoc)) 
        	then: [^assoc value].
	^self].

    self check: assoc forArity: 4.

    self unify: assoc key tail tail tail head 
		with: ((self first: assoc) perform: (self second: assoc) 
			withArguments: (self third: assoc) topForms)  
        	then: [^assoc value]

! !

!Prolog methodsFor: 'success-failure' stamp: 'spfa 6/23/2008 15:18'!
primlogicTrue: assoc
        "Succeed always."
    assoc key ifNotNil: [^self].
    ^assoc value! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/23/2008 15:48'!
primlogicVar: assoc
        "Succeed if the argument is an
         unbound variable."
    self check: assoc forArity: 1.
    (self first: assoc) class == LogicUnbound
        ifTrue: [^assoc value]! !

!Prolog methodsFor: 'classifying terms' stamp: 'spfa 6/23/2008 13:58'!
primlogicWrite: assoc
        "Write all the arguments to the output stream."
    | value |
    assoc key do: [:argument |
        value := self allValue: argument.
        self outputStream nextPutAll:
            ((value isKindOf: String)
                ifTrue: [value]
                ifFalse: [value prologPrintString]).
	   self finalizeOutput].
    ^assoc value! !

!Prolog methodsFor: 'interaction' stamp: 'spfa 6/16/2008 15:03'!
prompt

	^ self class asString, ' ?-'! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/23/2008 22:14'!
purge: aSymbol

	self database removeKey: aSymbol ifAbsent: []! !

!PrologInfo methodsFor: 'as yet unclassified' stamp: 'spfa 6/29/2008 21:30'!
readmeText
	"Text shown to the user after load"
	| s |
	s := String new writeStream.
	s nextPutAll: '
This is Prolog for Squeak, initially adapted by Bolot Kerimbaev from Prolog/V by Mike Teng,
now being refactored by Stephane Rollandin for Squeak 3.8 and newer.

For old-style Prolog workspace:
	PrologWorkspace openDemo.   "doIt"

For newer integrated browser & REPL:
	Family new openGui.		"doIt"
	Chapter2 new openGui.		"doIt"

The original paper from Mike Teng should be available at
	http://www.zogotounga.net/comp/squeak/v-prolog.pdf
...note that this is somewhat deprecated.

Home page:
	http://www.zogotounga.net/comp/squeak/prolog.htm



produced from package ';
		nextPutAll: self packageName;
		nextPutAll: ' on ';
		nextPutAll: Date today printString;
		space;
		nextPutAll: Time now printString;
		cr.
	^s contents.! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/20/2008 00:14'!
removeSelector: selector 
	
	super removeSelector: selector .
	self withAllSubclassesDo: [:pl | pl clearPredicates]! !

!PrologBrowser methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 14:06'!
repl: aREPLMorph

	repl _ aREPLMorph! !

!Prolog class methodsFor: 'database' stamp: 'spfa 6/23/2008 15:21'!
retract: anArray

	self new primlogicRetract: (PrologList with: anArray asPrologList) -> []
	! !

!Prolog class methodsFor: 'predicates' stamp: 'spfa 6/20/2008 00:48'!
selectorForPredicate: aString

	| symb |

	symb _ aString asSymbol.

	^ self predicates at: symb ifAbsent: [ | logicSymb primlogicSymb pred |

		(symb beginsWith: self prologKeyword) ifTrue: 
			[symb _ (symb allButFirst: self prologKeyword size) 
							withFirstCharacterDownshifted asSymbol].
		(symb beginsWith: ('prim', self prologKeyword)) ifTrue: 
			[self predicates at: symb put: symb. ^ symb].

		logicSymb _ self makeLogicSelector: symb.
		primlogicSymb _ ('prim', logicSymb, ':') asSymbol.
		pred _ (self canUnderstand: logicSymb)
			ifTrue: [logicSymb] ifFalse: [
				(self canUnderstand: primlogicSymb)
					ifTrue: [primlogicSymb] ifFalse: [symb]].
		self predicates at: symb put: pred.
		self predicates at: logicSymb put: pred.
		pred == primlogicSymb
			ifTrue: [self predicates at: pred put: pred].
		^ self selectorForPredicate: symb]
! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'spfa 6/8/2008 21:20'!
sourceCodeTemplate
	"Answer an expression to be edited and evaluated in order to define 
	methods in this class."

    ^ Logic prologKeyword, 'Predicate
"comment"
predicate(term1, term2) :-
    goal1(term3),
    goal2(term4).'! !

!Prolog class methodsFor: 'prolog-compilation' stamp: 'bolot 7/12/1999 19:22'!
wantsChangeSetLogging
	^true! !

!Prolog class methodsFor: 'querying' stamp: 'spfa 6/24/2008 18:05'!
which: anArray

	^ self new inferSmalltalk: (PrologList car: (anArray asPrologList as: Relation))! !
